リッチテキストエディタコントロールが提供する入力を制御する機能について解説します。
最大文字数の指定
maxLengthプロパティを設定することで、リッチテキストエディタコントロールへの入力可能文字数を設定できます。コマンドから最大文字数を指定する場合は、ChangeMaxLengthコマンドを使用します。
リッチテキストエディタに最大文字数を指定した場合、最大文字数以上を入力不可となります。また、コピーペーストやテンプレート挿入を行う場合は、最大文字数以上の内容が削除されます。
設定例は以下の通りです。
maxLengthプロパティを使用する
ChangeMaxLengthコマンドを使用する
また、getContentLengthメソッドとgetSelectionLengthメソッドを使用して、それぞれ改行を除いた全ての文字数と選択中の文字数を取得できます。
改行コードの取り扱い
リッチテキストエディタからクリップボードへ改行を含む文字列をコピー、または貼り付けた場合の改行コードを削除することを設定できます。ツールバーの項目をONに設定するか、filterCrlfプロパティをtrueに設定します。また、コマンドの使用で設定することができます。
filterCrlfプロパティを使用する
ToggleFilterCrlfコマンドを使用する
注意事項
filterCrlfプロパティをtrueに適用するには、リッチテキストエディタの貼り付ける形式がテキストに設定する必要があります。そのため、filterCrlfプロパティをtrueに設定すると貼り付ける形式が自動的にテキストに変更されます。
import "@grapecity/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css";
import { InputMan } from "@grapecity/inputman.richtexteditor";
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
const gcRichTextEditor = new InputMan.GcRichTextEditor(
document.getElementById("gcRichTextEditor"),
{
baseUrl:
window.location.origin +
"/inputmanjs/demos/lib/purejs/node_modules/@grapecity/inputman.richtexteditor/JS",
plugins: ["all"],
toolbar: [
GC.InputMan.GcRichTextEditorToolbarItem.FilterCrlf,
GC.InputMan.GcRichTextEditorToolbarItem.PasteText,
],
filterCrlf: true,
maxLength: 5,
}
);
document.getElementById("maxLength").addEventListener("change", (e) => {
gcRichTextEditor.maxLength = parseInt(e.target.value);
});
document
.getElementById("setLengthByTextElement")
.addEventListener("change", (e) => {
gcRichTextEditor.lengthUnit = GC.InputMan.LengthUnitType.TextElement;
});
document.getElementById("setLengthByByte").addEventListener("change", (e) => {
gcRichTextEditor.lengthUnit = GC.InputMan.LengthUnitType.Byte;
});
document.getElementById("filterCrlf").addEventListener("change", (e) => {
e.target.selectedIndex == 0
? (gcRichTextEditor.filterCrlf = true)
: (gcRichTextEditor.filterCrlf = false);
});
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>リッチテキストエディタコントロール - 入力の制御</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<textarea id="gcRichTextEditor"></textarea>
<table class="sample">
<tr>
<th>最大文字数</th>
<td>
<input type="number" value="5" min="0" id="maxLength">
<label><input type="radio" name="setLengthByByte" onchange="setLengthByByte" id="setLengthByTextElement"
checked>文字単位</label>
<label><input type="radio" name="setLengthByByte" onchange="setLengthByByte"
id="setLengthByByte">バイト単位</label>
</td>
</tr>
<tr>
<th>改行コードの扱い</th>
<td>
<select id="filterCrlf">
<option selected>すべての改行コードを削除</option>
<option>そのまま使用</option>
</select>
</td>
</tr>
</table>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@grapecity/inputman': 'npm:@grapecity/inputman/index.js',
'@grapecity/inputman/CSS': 'npm:@grapecity/inputman/CSS',
'@grapecity/inputman.richtexteditor': 'npm:@grapecity/inputman.richtexteditor/index.js',
'@grapecity/inputman.richtexteditor/CSS': 'npm:@grapecity/inputman.richtexteditor/CSS',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

リッチテキストエディタコントロールが提供する入力を制御する機能について解説します。
最大文字数の指定
maxLengthプロパティを設定することで、リッチテキストエディタコントロールへの入力可能文字数を設定できます。コマンドから最大文字数を指定する場合は、ChangeMaxLengthコマンドを使用します。
リッチテキストエディタに最大文字数を指定した場合、最大文字数以上を入力不可となります。また、コピーペーストやテンプレート挿入を行う場合は、最大文字数以上の内容が削除されます。
設定例は以下の通りです。
maxLengthプロパティを使用する
ChangeMaxLengthコマンドを使用する
また、getContentLengthメソッドとgetSelectionLengthメソッドを使用して、それぞれ改行を除いた全ての文字数と選択中の文字数を取得できます。
改行コードの取り扱い
リッチテキストエディタからクリップボードへ改行を含む文字列をコピー、または貼り付けた場合の改行コードを削除することを設定できます。ツールバーの項目をONに設定するか、filterCrlfプロパティをtrueに設定します。また、コマンドの使用で設定することができます。
filterCrlfプロパティを使用する
ToggleFilterCrlfコマンドを使用する
注意事項
filterCrlfプロパティをtrueに適用するには、リッチテキストエディタの貼り付ける形式がテキストに設定する必要があります。そのため、filterCrlfプロパティをtrueに設定すると貼り付ける形式が自動的にテキストに変更されます。
import * as React from "react";
import * as ReactDom from "react-dom";
import { GcRichTextEditor } from "@mescius/inputman.richtexteditor.react";
import * as GCCommon from "@mescius/inputman";
import "@mescius/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css";
import "@mescius/inputman.richtexteditor/JS/plugins/all";
import "@mescius/inputman/CSS/gc.inputman-js.css";
import "./styles.css";
import { useState } from "react";
GCCommon.InputMan.appearanceStyle = GCCommon.InputMan.AppearanceStyle.Modern;
const App = () => {
const [maxLength, setMaxLength] = useState(5);
const rich = React.createRef();
const plugins = [GC.InputMan.GcRichTextEditorPluginItem.All];
const toolbar = [
GC.InputMan.GcRichTextEditorToolbarItem.FilterCrlf,
GC.InputMan.GcRichTextEditorToolbarItem.PasteText,
];
const [lengthUnit, setLengthUnit] = useState(GC.InputMan.LengthUnitType.TextElement);
const [filterCrlf, setFilterCrlf] = useState(true);
return (
<div>
<GcRichTextEditor
ref={rich}
plugins={plugins}
toolbar={toolbar}
filterCrlf={filterCrlf}
maxLength={maxLength}
lengthUnit={lengthUnit}
/>
<table class="sample">
<tr>
<th>最大文字数</th>
<td>
<input
type="number"
value={maxLength}
min="0"
id="maxLength"
onChange={(e) => {
rich.current.getNestedIMControl().maxLength = parseInt(
e.target.value
);
setMaxLength(e.target.value);
}}
/>
<label><input type="radio" name="setLengthByByte" onChange={() => setLengthUnit('textElement')} checked={lengthUnit === "textElement"} />文字単位</label>
<label><input type="radio" name="setLengthByByte" onChange={() => setLengthUnit('byte')} />バイト単位</label>
</td>
</tr>
<tr>
<th>改行コードの扱い</th>
<td>
<select
id="filterCrlf"
onChange={(e) => { e.target.selectedIndex == 0 ? setFilterCrlf(true) : setFilterCrlf(false); }}
>
<option selected>すべての改行コードを削除</option>
<option>そのまま使用</option>
</select>
</td>
</tr>
</table>
</div>
);
};
ReactDom.render(<App />, document.getElementById("app"));
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>リッチテキストエディタコントロール - 書式の設定</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman.react': 'npm:@mescius/inputman.react/GcInputMan.component.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.comment': 'npm:@mescius/inputman.comment/index.js',
'@mescius/inputman.comment.react': 'npm:@mescius/inputman.comment.react/GcInputMan.component.js',
'@mescius/inputman.comment/CSS': 'npm:@mescius/inputman.comment/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
'@mescius/inputman.richtexteditor.react': 'npm:@mescius/inputman.richtexteditor.react/GcInputMan.component.js',
'@mescius/inputman.richtexteditor/CSS': 'npm:@mescius/inputman.richtexteditor/CSS',
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.react.grid': 'npm:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.base': 'npm:@mescius/wijmo.react.base/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'react-dom/client': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
'node_modules': {
defaultExtension: 'js',
},
},
});
})(this);